#
# Tool Interface Tool xilinx11.memo
# Version 2.05
#
TOP="MOD_memo"
DEVICE="xc2s100-tq144"
SPEED="5"
PROM="xc18v01"
OBJDIR="obj"
SRCDIR="."
DESIGN="memo"
LOG="memo.log"
DUP="tee"
if [ "X$XILINX" = "X" ]
then
  _XILINX="/opt/Xilinx9"
else
  _XILINX=$XILINX
fi
XILINX=$_XILINX
if [ "X$SCRAM" = "X" ]
then
  _SCRAM="/opt/alliance/bin/scram"
else
  _SCRAM=$SCRAM
fi
SCRAM=$_SCRAM
res="0"
VHDL[1]="memo"
VHDL[2]="memo_main"
VHDL[3]="conpro"
SYNSET="-fsm_extract YES -fsm_encoding Sequential -fsm_style lut -mux_extract YES -mux_style Auto -ram_extract Yes -ram_style Block -rom_extract Yes -rom_style Auto -mult_style lut -priority_extract Yes -shreg_extract Yes -decoder_extract Yes -shift_extract Yes -opt_mode speed -opt_level 1 -iobuf YES -iob Auto -max_fanout 100 -xor_collapse Yes -resource_sharing Yes -slice_packing Yes -slice_utilization_ratio 100 -slice_utilization_ratio_maxmargin 5 -bufg 4 -register_duplication Yes -register_balancing No -equivalent_register_removal Yes -optimize_primitives No -tristate2logic No -glob_opt AllClockNets -iuc NO "
MAPSET="-pr b -k 4 -c 100 -tx off "
PARSET="-t 1 "
BITGEN_CONF=""
RECLEN="1024"
do_fpga()
{
  echo [creating xsvf fpga file...]
  rm -f  "memo_xc2s100-tq144.xsvf" "memo_xc2s100-tq144.svf" "memo_xc2s100-tq144.bit"
  CMD="impact.cmd"
  rm -f $CMD; touch $CMD
  echo "setMode -bsfile" >> $CMD
  echo "setCable -port svf -file memo_xc2s100-tq144.svf" >> $CMD
  echo "addDevice -p 1 -file memo.bit" >> $CMD
  echo "identify" >> $CMD
  echo "program -e -p 1" >> $CMD
  echo "quit" >> $CMD
  EXEC="impact -batch "$CMD
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  check
  rm -f $CMD; touch $CMD
  echo "svf2xsvf -fpga -r 0 -rlen 1024 -i memo_xc2s100-tq144.svf -o memo_xc2s100-tq144.xsvf" >> $CMD
  echo "quit" >> $CMD
  EXEC="impact -batch "$CMD
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  cp "memo_xc2s100-tq144.xsvf" "../."
}
do_prom()
{
  echo [creating xsvf prom file...]
  rm -f  "memo_xc18v01.xsvf" "memo_xc18v01.svf"
  CMD="impact.cmd"
  rm -f $CMD; touch $CMD
  echo "setMode -pff" >> $CMD
  echo "setsubMode -pffserial" >> $CMD
  echo "addpromdevice -p 1 -name xc18v01" >> $CMD
  echo "addCollection -name memo" >> $CMD
  echo "addDesign -version 0 -name 0000" >> $CMD
  echo "addDeviceChain -index 0" >> $CMD
  echo "addDevice -p 1 -file memo.bit" >> $CMD
  echo "generate" >> $CMD
  echo "quit" >> $CMD
  EXEC="impact -batch "$CMD
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  check
  rm -f $CMD; touch $CMD
  echo "setMode -bsfile" >> $CMD
  echo "setCable -port svf -file memo_xc18v01.svf" >> $CMD
  echo "addDevice -p 1 -part xc18v01" >> $CMD
  echo "setAttribute -position 1 -attr configFileName -value memo.mcs" >> $CMD
  echo "identify" >> $CMD
  echo "program -e -p 1 -v" >> $CMD
  echo "quit" >> $CMD
  EXEC="impact -batch "$CMD
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  check
  rm -f $CMD; touch $CMD
  echo "svf2xsvf  -i memo_xc18v01.svf -o memo_xc18v01.xsvf" >> $CMD
  echo "quit" >> $CMD
  EXEC="impact -batch "$CMD
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  cp "memo_xc18v01.xsvf" "../."
}
do_ucf()
{
  echo [creating ucf file...]
  UCF="../memo.ucf"
  [ -r $UCF ]
  if [ $? = 0 ]
  then
    _RES=1
  else
    _RES=0
  fi
  if [ $_RES = "1" ]
  then
    echo "Keeping existing constraint file "$UCF
  else
    rm -f $UCF; touch $UCF
    IND="1"
    echo "#NET \"SW<0>\" LOC = \"\";
    #NET \"SW<1>\" LOC = \"\";
    #NET \"SW<2>\" LOC = \"\";
    #NET \"SW<3>\" LOC = \"\";" >> $UCF
    echo "#NET \"LED_RD<0>\" LOC = \"\";
    #NET \"LED_RD<1>\" LOC = \"\";
    #NET \"LED_RD<2>\" LOC = \"\";
    #NET \"LED_RD<3>\" LOC = \"\";
    #NET \"LED_RD<4>\" LOC = \"\";
    #NET \"LED_RD<5>\" LOC = \"\";
    #NET \"LED_RD<6>\" LOC = \"\";
    #NET \"LED_RD<7>\" LOC = \"\";" >> $UCF
    echo "#NET \"CLK\" LOC = \"\";" >> $UCF
  fi
}
do_bitgen()
{
  echo [starting bitgen...]
  BITCONF="memo.bitgen_conf"
  rm -f $BITCONF; touch $BITCONF
  echo "" >> $BITCONF
  EXEC="bitgen -w -f "$BITCONF" memo.ncd"
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  cp "memo.bit" "../."
}
do_place()
{
  echo [starting place and route...]
  EXEC="par -w "$PARSET" memo_map.ncd memo.ncd memo.pcf"
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  cat "memo.par" >> "memo.log"
}
do_map()
{
  echo [starting map...]
  EXEC="map -p xc2s100-tq144 "$MAPSET" -o memo_map.ncd memo.ngd memo.pcf"
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  check
  cat "memo_map.mrp" >> "memo.log"
}
do_trans()
{
  echo [starting ngdbuild...]
  EXEC="ngdbuild -p xc2s100-tq144 -uc ../memo.ucf -dd . memo.ngc memo.ngd"
  { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
  _EXEC_RES=`cat /tmp/_EXEC_RES`
  rm -f /tmp/_EXEC_RES
  res=$_EXEC_RES
  check
}
do_scram()
{
  for file in "${VHDL[@]}"
  do
    rm -f  "work._savant_lib"
    _BASENAME=$file
    SRC=${_BASENAME##*/}".vhdl"
    _DATE=`date`
    DATE=$_DATE
    echo $DATE >> "memo.log"
    echo $DATE
    echo [$SCRAM" "$SRC"]" >> "memo.log"
    echo [$SCRAM" "$SRC"]"
    _TIME=`gdate +%s`
    EXEC=$SCRAM" "$SRC
    { $EXEC; echo $? > /tmp/_EXEC_RES; } 2>&1 | tee -a "memo.log"
    echo $_TIME >> "memo.log"
    _EXEC_RES=`cat /tmp/_EXEC_RES`
    rm -f /tmp/_EXEC_RES
    res=$_EXEC_RES
    rm -f  "work._savant_lib"
  done
}
do_synth()
{
  echo [building run and project scripts...]
  make_xst_runscript
  check
  make_proj
  check
  echo [starting xst...]
  EXEC="xst -ifn memo.xst_run -ofn memo_xilinx.log"
  $EXEC
  _EXEC_RES=$?
  res=$_EXEC_RES
  check
  cat "memo_xilinx.log" >> "memo.log"
}
make_proj()
{
  PROJFILE="memo.prj"
  rm -f $PROJFILE; touch $PROJFILE
  _DIRNAME1="memo"
  _DIRNAME2=${_DIRNAME1%/*}
  if [ X"$_DIRNAME2" = X"$_DIRNAME1" ]
  then
  _DIRNAME2="."
  fi
  DIR=$_DIRNAME2
  _BASENAME="memo"
  FILE=${_BASENAME##*/}
  if [ $DIR = "." ]
  then
    echo "vhdl work ../"$FILE".vhdl" >> $PROJFILE
  else
    echo "vhdl work "$DIR"/"$FILE".vhdl" >> $PROJFILE
  fi
  _DIRNAME1="memo_main"
  _DIRNAME2=${_DIRNAME1%/*}
  if [ X"$_DIRNAME2" = X"$_DIRNAME1" ]
  then
  _DIRNAME2="."
  fi
  DIR=$_DIRNAME2
  _BASENAME="memo_main"
  FILE=${_BASENAME##*/}
  if [ $DIR = "." ]
  then
    echo "vhdl work ../"$FILE".vhdl" >> $PROJFILE
  else
    echo "vhdl work "$DIR"/"$FILE".vhdl" >> $PROJFILE
  fi
  _DIRNAME1="conpro"
  _DIRNAME2=${_DIRNAME1%/*}
  if [ X"$_DIRNAME2" = X"$_DIRNAME1" ]
  then
  _DIRNAME2="."
  fi
  DIR=$_DIRNAME2
  _BASENAME="conpro"
  FILE=${_BASENAME##*/}
  if [ $DIR = "." ]
  then
    echo "vhdl work ../"$FILE".vhdl" >> $PROJFILE
  else
    echo "vhdl work "$DIR"/"$FILE".vhdl" >> $PROJFILE
  fi
}
make_xst_runscript()
{
  rm -f "memo.xst_run"; touch "memo.xst_run"
  CMD="run -ifn memo.prj -ifmt mixed -ofn memo -ofmt NGC -p xc2s100-tq144 "$SYNSET" -top MOD_memo"
  echo $CMD >> "memo.xst_run"
}
finish()
{
  cat "memo.log" >> "../memo.log"
  cd "-"
}
init()
{
  [ -r "obj" ]
  if [ $? = 0 ]
  then
    _RES=1
  else
    _RES=0
  fi
  if [ $_RES = "0" ]
  then
    mkdir -p "obj"
  fi
  cd "obj"
  rm -f "memo.log"; touch "memo.log"
}
check()
{
  if [ ! $res = "0" ]
  then
    echo [Abort due to errors building target.]
    exit "1"
  fi
}
if [ $# = 0 ]
then
  echo "Usage: memo.xilinx11.tool.sh [init vhdl synth tech svf ucf]"
fi
for TARGET in $@ 
do
  echo "Building target [$TARGET] ..."
  case $TARGET in
    init)
      init
      check
      finish
      ;;
    vhdl)
      init
      do_scram
      check
      finish
      ;;
    synth)
      init
      do_synth
      check
      finish
      ;;
    tech)
      init
      do_ucf
      check
      do_trans
      check
      do_map
      check
      do_place
      check
      do_bitgen
      check
      do_prom
      check
      do_fpga
      check
      finish
      ;;
    svf)
      init
      do_prom
      check
      do_fpga
      check
      finish
      ;;
    ucf)
      init
      do_ucf
      check
      ;;
  esac
done
